////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2010 Exor International Inc. All rights reserved.
//
// MODULE DESCRIPTION: javascript interface -- simple alarm test.
//
//
////////////////////////////////////////////////////////////////////////////



//for function sendmail
var serverport = 25;
var serverip = "";
var bAuthEnabled = false;
var strAuthUsername = "";
var strAuthPassword = "";
var timeout = 60;
var mail;
var encode;
var from = "";
var to = "";
var subject = "";

/*
function alarm(eventId)
{
	_Debug.Trace(" ********* NEW - Alarm for event Id: " + eventId+ "\n");

   sendmail(eventId);

}
*/
/* msgbody will be ignored if we find it in xml settings file */
//function sendmail(eventId)
function sendmail(serverId, emailInfoId){
	_Debug.Trace("Executing javascrip sendmail function...\n");

	//var aname = "alarm " + eventId;
	var systemFile = new XMLDOMFile("config/system.xml");
	if(!systemFile.parse())	{
		_Debug.Trace("Failed  to parse system.xml. bailing out. \n");
		return;
	}
	var projectRelativePath = "";
	var systemRootNode = systemFile.getRootNode();
	//get projectRelativePath node
	var projRelativeNode = systemFile.getNodeByName("projectRelativePath", systemRootNode);
	if(projRelativeNode != null)	{
		projectRelativePath = projRelativeNode.getValue();
	}
 	var emailInfoFilePath = "config/emailinfo.xml";
 	if(projectRelativePath!="")
 		emailInfoFilePath = projectRelativePath + "/" + emailInfoFilePath;
	var emailInfoFile = new XMLDOMFile(emailInfoFilePath);
   if(!emailInfoFile.parse())   {
      _Debug.Trace("failed to parse emailinfo.xml. bailing out.\n");
      return;
   }

	var rootNode2 = emailInfoFile.getRootNode();

   //search for a node with with id == "alarmN" (from root)
   var mailinfoNode2 = emailInfoFile.getNodeByNameAndContent("id", emailInfoId, rootNode2);
   if(mailinfoNode2 == null) {
      _Debug.Trace("No alarm info for: " + aname + "\n");
      return;
   }
   	// get the enable flag
	var enableNode = emailInfoFile.getNodeByName("enable", mailinfoNode2);
	if(enableNode != null){
			// drop out if not enabled
		var enable = enableNode.getValue();
		if (enable!="1" && enable!="true") {
       _Debug.Trace(aname + "  disabled.  No e-mail sent\n");
	   	return;
	  }
  }

	var emailConfigFilePath = "config/emailConfig.xml";
	if(projectRelativePath!="")
		emailConfigFilePath = projectRelativePath + "/" + emailConfigFilePath;
		
	var genEmailInfoFile = new XMLDOMFile(emailConfigFilePath);
   if(!genEmailInfoFile.parse()){
      _Debug.Trace("failed to parse. bailing out.\n");
      return;
   }

	var rootNode = genEmailInfoFile.getRootNode();

   //search for a node with with id == "testserver" (from root)
   var mailinfoNode = genEmailInfoFile.getNodeByNameAndContent("id", serverId, rootNode);
   if(mailinfoNode == null){
      _Debug.Trace("could not find any general email setting for account hoover. bailing out.\n");
      return;
   }

	node = genEmailInfoFile.getNodeByName("serverport", mailinfoNode);
	if(node == null){
	   _Debug.Trace("could not find the serverport tag. bailing out.\n");
	   return;
   }
   serverport = node.getValue();

	node = genEmailInfoFile.getNodeByName("serverip", mailinfoNode);
	if(node == null){
	   _Debug.Trace("could not find the serverip tag. bailing out.\n");
	   return;
   }
   serverip = node.getValue();

	node = genEmailInfoFile.getNodeByName("requireauth", mailinfoNode);
	if(node == null){
	   _Debug.Trace("could not find the requireauth tag. bailing out.\n");
	   return;
   }
	if (node.getValue() == "true")
      bAuthEnabled = true;
  else
   		bAuthEnabled = false;

	node = genEmailInfoFile.getNodeByName("user", mailinfoNode);
	if(node == null){
	   _Debug.Trace("could not find the user tag. bailing out.\n");
	   return;
   }
	strAuthUsername = node.getValue();

	node = genEmailInfoFile.getNodeByName("password", mailinfoNode);
	if(node == null){
	   _Debug.Trace("could not find the passwd tag. bailing out.\n");
	   return;
   }
	strAuthPassword = node.getValue();


   var node = emailInfoFile.getNodeByName("from", mailinfoNode2);
	if(node == null){
	   _Debug.Trace("could not find the from tag. bailing out.\n");
	   return;
   }
   from = node.getValue();


	node = emailInfoFile.getNodeByName("to", mailinfoNode2);
	if(node == null){
	   _Debug.Trace("could not find the to tag. bailing out.\n");
	   return;
   }
	to = node.getValue();

	node = emailInfoFile.getNodeByName("subject", mailinfoNode2);
	if(node == null){
	   _Debug.Trace("could not find the subject tag. bailing out.\n");
	   return;
   }
	subject = node.getValue();

	node = emailInfoFile.getNodeByName("message", mailinfoNode2);
	if(node == null){
	   _Debug.Trace("could not find the message tag. bailing out.\n");
	   return;
   }
	msgbody = node.getValue();

		// read in tag data
	var tagList;
	node = emailInfoFile.getNodeByName("taglist", mailinfoNode2);
	if(node != null) {
			// tag names are , separated
		var strTags = node.getValue();
		tagList = strTags.split(",");
	}
	

	//_Debug.Trace("set the SMTP server address to "+serverip+"\n");
	Mailer.setServer(serverip);

   //_Debug.Trace("set the SMTP server port to "+serverport+"\n");
	Mailer.setPort(serverport);

	//_Debug.Trace("set the SMTP timeout in seconds to "+timeout+"\n");
	Mailer.setTimeout(timeout);

	//_Debug.Trace("set the ESMTP authentication to "+bAuthEnabled+"\n");
	Mailer.setAuthEnabled(bAuthEnabled);

	if(bAuthEnabled){	
		// condition not really required, just for nicer printout
		//_Debug.Trace("set the ESMTP username to "+strAuthUsername+"\n");
		Mailer.setAuthUsername(strAuthUsername);

		//_Debug.Trace("set the ESMTP password to "+strAuthPassword+"\n");
		Mailer.setAuthPassword(strAuthPassword);
	}
	
	// replace xml returns
	msgbody = msgbody.replace(/\\n/g, " \n");
	
		// read the tag values and insert them in the messge body.  The message body should have %1, %2, %3, etc 
	for (var i=0; i<tagList.length; i++) {
		tagValue = readTag(tagList[i]);
		var labelId = "@"+(i+1);
		if (tagValue!="") {
			msgbody = msgbody.replace(labelId, tagValue);
		} else {
			msgbody = msgbody.replace(labelId, "---");
		}
	}

	
	var alarmDate = new Date();

	var messageIntro = alarmDate + " \n \n";
	
  var message = messageIntro + msgbody + "\n  \n";

   //_Debug.Trace("2--message: "+message+"\n");

	mail = Mailer.create(from,to,subject,message);

	_Debug.Trace("sending mail.....\n");
	_Debug.Trace(msgbody+"\n \n");
	if(!Mailer.send(mail)){
		encode = Mailer.getErrorCode();
		_Debug.Trace("failed to send e-mail message. Error code:"+encode+"\n");
	}else{
		_Debug.Trace("....done!\n");
	}

}

function readTag(strTagName)
{
	strTagData = "";
	oTag = Icu.TagFactory.getTag(strTagName);
	if (oTag != null)
	{
//		_Debug.Trace("strTagName found " + strTagName+ "\n");
		oState =	oTag.readDevice();
		strTagData = oState.valueAsString();
//		_Debug.Trace("strTagData " + strTagData+ "\n");
	}
   return strTagData;
}

function getFormatedDate()
{
	var curdate = new Date();

	var years = curdate.getYear() + 1900;
	var months = new Array('Jan','Feb','Mar','Apr',
		'May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

	var weekday = new Array(7);
	weekday[0]="Sun";
	weekday[1]="Mon";
	weekday[2]="Tue";
	weekday[3]="Wed";
	weekday[4]="Thu";
	weekday[5]="Fri";
	weekday[6]="Sat";

	var hours = curdate.getHours();
	var ampm = "A.M.";
	if (hours == 0) hours = 12;
	if (hours > 11)
	 		ampm = "P.M.";
	if (hours > 12)
		hours -= 12;

	var strDate = weekday[curdate.getDay()] + " " + months[curdate.getMonth()] +
		 " " + curdate.getDate() + ", " + years.toString(10) + " " + hours.toString() + ":" +
		 leadingZero(curdate.getMinutes()) + ":" + leadingZero(curdate.getSeconds()) +
		 " " + ampm;


	return strDate;

}

function leadingZero(nr)
{
		if (nr < 10) nr = "0" + nr;
		return nr;
}
function sendEmailAdv(serverId, emailInfoId){
	_Debug.Trace("Executing javascrip sendmail function...\n");
	Mailer.sendMailAdv(serverId, emailInfoId);
}