rm /tmp/.X0-lock

export PATH=$PATH:/bin:/usr/bin/:/sbin:/usr/sbin

if [ ! -e /var/lib/dbus/machine-id ]; then
	dbus-uuidgen > /var/lib/dbus/machine-id
fi

# system dbus for EPAD
mkdir -p /var/run/dbus
dbus-daemon --system --nofork --nopidfile &
DBUSPID=$!

# hook to execute custom script if provided by image
if [ -e /custom-startup.sh ] ; then
	source /custom-startup.sh
fi

# start Xserver
xinit /etc/X11/Xsession -- /usr/bin/Xorg -nolisten tcp -br -pn > /var/log/Xsession.log 2>&1

echo "Cleanup child processes..."
kill $DBUSPID 2> /dev/null
echo "Kill EPAD dbus service"
killall EPAD 2> /dev/null

# hook to execute custom script if provided by image
if [ -e /custom-exit.sh ] ; then
	source /custom-exit.sh
fi
